#include "MLista.h"

namespace MLista
{ 
    TLista CrearLista()
    {
        return NULL;   
    }
    
    bool ListaVacia(TLista l)
    {
        return (l==NULL);
    }    
    
    bool ListaLlena(TLista l)
    {
        bool esta_llena;
        TLista aux;
        
        aux = new (TNodo);
        esta_llena = (aux==NULL);
        
        if (!esta_llena)
        {
           delete(aux);             
        } 
        
        return esta_llena;   
    }
    
    void InsertarLista(TLista &l, TAsignatura a, TError &error)
    {
         TLista nuevo;
         
         if (ListaLlena(l))
         {
             error = SinMemoria;              
         }
         else if ( (ListaVacia(l)) || (Codigo(a) < Codigo(l->asignatura)) )
         {
              error = NoError;
              nuevo = new (TNodo);
              nuevo -> asignatura = a;
              nuevo->sig = l;
              l=nuevo;
         }
         else if ( Codigo(a) == Codigo(l->asignatura) )
         {
              error = AsignaturaExiste;
         }
         else
         {
             InsertarLista(l->sig,a, error);
         }
         
    }
    
    void MostrarLista(TLista l)
    {
         TLista ptr;
         
         ptr=l;
         while (ptr!=NULL)
         {
               EscribeAsignatura(ptr->asignatura);
               ptr = ptr->sig;
         }
    }
    
    void SacarPrimeroLista(TLista &l, TAsignatura &a, TError &error)
    {
         TLista ptr;
         
         if (ListaVacia(l))
         {
             error = ErrorListaVacia;              
         }
         else
         {
             ptr=l;
             a = l->asignatura;
             l = l->sig;
             delete(ptr);
             error = NoError;
         }
    }
    
    void EliminarLista(TLista &l, TNatural codigo, TError &error)
    {
         TLista ptr;
         
         if ( (ListaVacia(l)) || (codigo < Codigo(l->asignatura)) )
         {
              error = AsignaturaNoExiste;
         }
         else if ( codigo == Codigo(l->asignatura) )
         {
              error = NoError;
              ptr = l;
              l = l->sig;
              delete(ptr);
         }
         else
         {
             EliminarLista(l->sig,codigo, error);
         }
         
    }
    void DestruirLista(TLista &l)
    {
        TLista ptr;
         
        while (l!=NULL)
        {
              ptr=l;
              l = l->sig;
              delete(ptr);
        }
    }
    
}
