#ifndef _MUMA_h_
#define _MUMA_h_
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include "MError.h"
#include "MAsignatura.h"
#include "MLista.h"

using namespace std;
using namespace MError;
using namespace MAsignatura;
using namespace MLista;

namespace MUMA
{
     const TNatural MAX_CENTROS = 4;     
     typedef enum {informatica, telecomunicaciones, industriales, ciencias } TCentro;     
     typedef TLista TUMA[MAX_CENTROS];
     
     string Centro_a_Cadena(TCentro c);
     void Cadena_a_Centro(string s, TCentro &c, bool &ok);
     TCentro SUC(TCentro c);
     
     void CrearUMA(TUMA &tabla);
     void DestruirUMA(TUMA &tabla);
     void InsertarAsignaturaUMA(TUMA &tabla, TCentro c, TAsignatura a, TError &error);
     void ListarAsignaturasUMA(TUMA tabla);
     void CargarAsignaturasUMAFichero(TUMA &tabla, string nomFich, TError &error);
     void SalvarAsignaturasUMAFichero(TUMA &tabla, string nomFich, TError &error);
     void BuscarAsignaturaUMA(TUMA &tabla, TNatural codigo, 
                              TCentro &c, TAsignatura &a, TError &error);
     void MatricularAsignaturaUMA(TUMA &tabla, TNatural codigo, TError &error);
     void GestionAutomaticaMatriculacion(TUMA &tabla, string nomFich);
}
#endif
